/**
This file is part of a jTEM project.
All jTEM projects are licensed under the FreeBSD license 
or 2-clause BSD license (see http://www.opensource.org/licenses/bsd-license.php). 

Copyright (c) 2006-2010, Technische Universität Berlin, jTEM
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

-	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer.

-	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
**/

package de.jtem.java2d;

import java.awt.BorderLayout;
import java.awt.geom.Point2D;
import java.util.LinkedList;

import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JFrame;


public class Icon2D extends Point2D.Double{
	private static final long serialVersionUID = -8358764721492098988L;
	private transient int hashCode;
	private Icon icon;
	private int anchor = Annotation.CENTER;
	
	public Icon2D() {}
	
	public Icon2D(Icon icon, double x, double y, int anchor) {
		this.icon = icon;
		this.x = x;
		this.y = y;
		this.anchor = anchor;
		hashCode = new Object().hashCode();
	}
	
	public int getAnchor() {
		return anchor;
	}
	public void setAnchor(int anchor) {
		this.anchor = anchor;
	}
	
	public Icon getIcon() {
		return icon;
	}
	public void setIcon(Icon icon) {
		this.icon = icon;
	}
	
	public void setX(double x) {
		this.x = x;
	}

	public void setY(double y) {
		this.y = y;
	}
	
	public int hashCode() {
		return hashCode;
	}
	
	public boolean equals(Object o) {
		return this == o;
	}

	public static void main(String[] args) {
		JFrame frame = new JFrame("Label2D test");
		frame.getContentPane().setLayout(new BorderLayout());
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.setSize(400,400);
		LinkedList<Icon2D> i = new LinkedList<Icon2D>();
		Icon icon = new ImageIcon("C:/boy1-small.jpg");
		i.add(new Icon2D(icon,-1,0,Annotation.EAST));
		i.add(new Icon2D(icon,-1,-1,Annotation.NORTHEAST));
		i.add(new Icon2D(icon,0,-1,Annotation.NORTH));
		i.add(new Icon2D(icon,1,-1,Annotation.NORTHWEST));
		i.add(new Icon2D(icon,1,0,Annotation.WEST));
		i.add(new Icon2D(icon,1,1,Annotation.SOUTHWEST));
		i.add(new Icon2D(icon,0,1,Annotation.SOUTH));
		i.add(new Icon2D(icon,-1,1,Annotation.SOUTHEAST));
		i.add(new Icon2D(icon,0,0,Annotation.CENTER));
		SceneComponent s = new SceneComponent();
		s.getIcons().addAll(i);
		Viewer2D viewer = new Viewer2D();
		viewer.getRoot().addChild(s);
		frame.getContentPane().add(viewer);
		frame.setVisible(true);
	}
}
