/**
This file is part of a jTEM project.
All jTEM projects are licensed under the FreeBSD license 
or 2-clause BSD license (see http://www.opensource.org/licenses/bsd-license.php). 

Copyright (c) 2006-2010, Technische Universität Berlin, jTEM
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

-	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer.

-	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
**/

package de.jtem.java2dx;


import java.awt.geom.Line2D;
import java.awt.geom.Point2D;

public class Line2DDouble extends Line2D.Double{
	private transient int hashCode;
	
	public Line2DDouble() {
		hashCode = new Object().hashCode();
	}
	
	public Line2DDouble(double x1, double y1, double x2, double y2) {
		super(x1,y1,x2,y2);
		hashCode = new Object().hashCode();
	}
	
	public Line2DDouble(Point2D.Double p1, Point2D.Double p2) {
		this(p1.x, p1.y, p2.x, p2.y);
	}
	
	public Line2DDouble(Line2D.Double l) {
		this(l.x1,l.y1,l.x2,l.y2);
	}
	
	public Point2DDouble getP1() {
		return new Point2DDouble(x1,y1);
	}
	
	public Point2DDouble getP2() {
		return new Point2DDouble(x2,y2);
	}
	
	public Line2DDouble(Line2DDouble p) {
		super(p.x1, p.y1, p.x2, p.y2);
	}
	
	public void setX1(double x1) {
		this.x1 = x1;
	}
	
	public void setY1(double y1) {
		this.y1 = y1;
	}
	public void setX2(double x2) {
		this.x2 = x2;
	}
	
	public void setY2(double y2) {
		this.y2 = y2;
	}
	
	public String toString() {
		return "Line2DDouble["+x1+", "+y1+", "+x2+", "+y2+"]";
	}
	
	public int hashCode() {
		return hashCode;
	}
	
	public boolean equals(Object o) {
		return this==o;
	}
}
