/**
This file is part of a jTEM project.
All jTEM projects are licensed under the FreeBSD license 
or 2-clause BSD license (see http://www.opensource.org/licenses/bsd-license.php). 

Copyright (c) 2006-2010, Technische Universität Berlin, jTEM
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

-	Redistributions of source code must retain the above copyright notice, 
	this list of conditions and the following disclaimer.

-	Redistributions in binary form must reproduce the above copyright notice, 
	this list of conditions and the following disclaimer in the documentation 
	and/or other materials provided with the distribution.
 
THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS 
BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT 
OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY 
OF SUCH DAMAGE.
**/

package de.jtem.java2dx;


import java.awt.geom.RoundRectangle2D;

public class RoundRectangle2DDouble extends RoundRectangle2D.Double{
	private transient int hashCode;
	
	public RoundRectangle2DDouble() {
		hashCode = new Object().hashCode();
	}
	
	public RoundRectangle2DDouble(double x, double y, double w, double h, double arcw, double arch) {
		super(x,y,w,h,arcw,arch);
		hashCode = new Object().hashCode();
	}
	
	public RoundRectangle2DDouble(RoundRectangle2D.Double r) {
		this(r.x,r.y,r.width,r.height,r.arcwidth,r.archeight);
	}
	
	public void setX(double x) {
		this.x = x;
	}
	
	public void setY(double y) {
		this.y = y;
	}
	
	public void setWidth(double width) {
		this.width = width;
	}
	
	public void setHeight(double height) {
		this.height = height;
	}
	
	public void setArcWidth(double arcw) {
		arcwidth = arcw;
	}
	
	public void setArcHeight(double arch) {
		archeight = arch;
	}
	
	public String toString() {
		return "RoundRectangle2DDouble["+x+", "+y+", "+width+", "+height+", "+arcwidth+", "+archeight+"]";
	}
	
	public int hashCode() {
		return hashCode;
	}
	
	public boolean equals(Object o) {
		return this==o;
	}
}
